#!/usr/bin/perl -w
use strict;
use sigtrap;

# this script is an amalgam of combinations.pl and permutations.pl

my @source;
my @target;
my @output;
my $n = 7;

for (my $i = 0; $i < $n; ++$i) {
	push(@source, $i);
}

for (my $sub = 1; $sub < $n + 1; ++$sub) {
	@target = @source[0..($sub - 1)];
	&permute (@target);
	while ($target[0] != ($n - $sub)) {
		for (my $i = 1; $i < @target + 1; ++$i) {
			unless ($target[@target - $i] == $source[@source - $i]) {
				++$target[@target - $i];
				for (my $count = (@target + 1 - $i); $count < @target; ++$count) {
					$target[$count] = $target[$count - 1] + 1;
				}
				last;
			}
			if ($target[0] == ($n - $sub)) {
				last;
			}
		}
		&permute (@target);
	}
}

sub permute {
	for (my $count = 0; $count < @_; $count++) {
		my @list_to_cut = @_;
		push (@output, $list_to_cut[$count]);
		splice (@list_to_cut, $count, 1);
		if (@list_to_cut > 0) {
			&permute (@list_to_cut);
		} else {
			print "@output\n";
		}
		pop (@output);
	}
}
